
ControlP5 cp5;

DropdownList BirdSpeciesDDM;

void cp5Setup()
{
  //Drop Down Menu To Select Bird Species
  cp5 = new ControlP5(this);
  BirdSpeciesDDM = cp5.addDropdownList("bird species list")
                          .setPosition(width * 0.03, height * 0.6)
                          .setSize(200, 200);
  customize(BirdSpeciesDDM); 
  
  //Color Sliders
}
void drawGUI()
{
  cp5.draw(); 
}

void customize(DropdownList ddl)
{
  ddl.setBackgroundColor(color(190));
  ddl.setItemHeight(20);
  ddl.setBarHeight(15);
  ddl.captionLabel().set("Bird Species");
  ddl.captionLabel().style().marginTop  = 3;
  ddl.captionLabel().style().marginLeft = 3;
  ddl.valueLabel().style().marginTop    = 3;
  for(int i = 0; i < BirdSpecies.size(); i++)
  {
    ddl.addItem(BirdSpecies.get(i), i);
  }
  //ddl.scroll(0);
  ddl.setColorBackground(color(60));
  ddl.setColorActive(color(255, 128));
}

void controlEvent(ControlEvent event)
{
  if(event.isGroup())
  {
    if(event.group().name() == "bird species list")
    {
      selectedBird = BirdSpecies.get(int(event.group().value()));
      println("Bird: " + selectedBird + " was selected!");
      currentMonth = 0;
      current_week = 0;
      lastTime = millis();
      
      GoogleImageSetup();
      //printSelectedBirdyData();
    }
  }
  else if(event.isController())
  {
  }
}
